#include <iostream>
#include <cstring>

using namespace std;

const int MAXN = 105, MAXK = 10000/4 + 5;
int N, L, R, K, A[MAXN];
int sum, ans;
int dp[MAXN][MAXN][MAXK], solL[MAXN][MAXK];

int main() {
    ios::sync_with_stdio(false);
    cin >> N >> L >> R >> K;
    K = min(K, N * N / 4 + 2);
    for (int i = 1; i <= N; ++i)
        cin >> A[i];
    for (int i = L; i <= R; ++i)
        sum += A[i];
    for (int i = L; i <= R; ++i) {
        for (int j = L - 1; j > 0; --j) {
            for (int k = 0; k <= K; ++k) {
                dp[i][j][k] = max(dp[i][j][k], dp[i - 1][j][k]);
                dp[i][j][k] = max(dp[i][j][k], dp[i][j + 1][k]);
                int cost  = i - j;
                if (k >= cost)
                    dp[i][j][k] = max(dp[i][j][k], dp[i - 1][j + 1][k - cost] + A[i] - A[j]);
            }
        }
    }
    for (int i = L - 1; i <= R; ++i)
        for (int j = 0; j <= K; ++j)
            solL[i][j] = dp[i][1][j];

    memset(dp, 0, sizeof(dp));
    for (int i = R; i >= L; --i) {
        for (int j = R + 1; j <= N; ++j) {
            for (int k = 0; k <= K; ++k) {
                dp[i][j][k] = max(dp[i][j][k], dp[i + 1][j][k]);
                dp[i][j][k] = max(dp[i][j][k], dp[i][j - 1][k]);
                int cost = j - i;
                if (k >= cost)
                    dp[i][j][k] = max(dp[i][j][k], dp[i + 1][j - 1][k - cost] + A[i] - A[j]);
            }
        }
    }

    for (int i = L - 1; i <= R; ++i)
        for (int j = 0; j <= K; ++j)
            ans = max(ans, solL[i][j] + dp[i + 1][N][K - j]);
    cout << sum - ans << '\n';
    
    return 0;
}
