#include <iostream>
#include <set>

using namespace std;
using lll = __int128_t;

const int L = 100, MAXD = 3;
set<lll> found, nw[L];

void print(int sz, lll ans) {
    cout << sz << endl;
    for (int j = L - 1; j >= 0; --j)
        cout << ((ans & (lll(1)<<j)) ? "1" : "0");
    cout << endl;
    for (int j = 0; j < L; ++j)
        cout << nw[j].size() << " ";
    cout << endl;
}
void count(lll x, int pos) {
    set<lll>& cnw = nw[pos];
    cnw.clear();
    int len = pos + 1;
    for (lll j = 1; 2 * j <= len; ++j) {
        lll u = ((lll(1) << len) - 1) & x;
        u >>= len - j;
        u |= j << 60;
        lll v = ((lll(1) << (len - j)) - 1) & x;
        v >>= len - 2 * j;
        v |= j << 60;
        if (u == v && found.count(u) == 0 && cnw.count(u) == 0) {
            cnw.insert(u);
        }
    }
}
void rec(lll cur = 0, int pos = 1) {
    if (pos == L) {
        print(found.size(), cur);
        return;
    }

    for (lll i = 0; i <= 1; ++i) {
        cur |= (i << pos);
        count(cur, pos);
        if (nw[pos].size() > 0) {
            for (auto& fx : nw[pos])
                found.insert(fx);
            if (found.size() <= 3)
                rec(cur, pos + 1);
            for (auto& fx : nw[pos])
                found.erase(fx);
        }
        else
            rec(cur, pos + 1);
    }
}
int main() {
    ios::sync_with_stdio(false);
    rec();

    return 0;
}
